package org.bitbucket.bradleysmithllc.etlunit.util.regexp;

/*

		Regular expression class compiled by the Regular Expression Compiler 1.5.0-SNAPSHOT

*/

import java.util.Map;
import java.util.HashMap;
import java.util.regex.Pattern;
import java.util.regex.Matcher;

public final class SchemaMatchExpression
{
	public static final String PATTERN_RAW_TEXT = "(^|[^A-Za-z0-9_]+)(?{schemaName})(\\.)";
	private final String parameter_schemaName;
	public final String pattern_text;
	public final Pattern pattern;
	private final Map<String, Integer> groupOffsets = new HashMap<String, Integer>();

	private final Matcher matcher;
	private final CharSequence matchText;

	public static interface RegExpIterator
	{
		String replaceMatch(SchemaMatchExpression e);
	}


	public SchemaMatchExpression(CharSequence ch, String schemaName)
	{
		String s_pattern_text = PATTERN_RAW_TEXT.replaceAll("\\(\\?'[^']+'", "(");

		//schemaName >> (?{schemaName});
		parameter_schemaName = schemaName;

		s_pattern_text = s_pattern_text.replace("(?{schemaName})", parameter_schemaName);

		pattern_text = s_pattern_text;

		Pattern cpattern = Pattern.compile("(\\\\)?\\((\\?'([^']+)')?");

		Matcher m = cpattern.matcher(PATTERN_RAW_TEXT);

		int groupCount = 1;

		while (m.find())
		{
			if (m.group(1) != null)
			{
				continue;
			}

			String groupName = m.group(3);

			if (groupName != null)
			{
				groupOffsets.put(groupName, new Integer(groupCount));
			}

			groupCount++;
		}

		pattern = Pattern.compile(pattern_text, Pattern.CASE_INSENSITIVE | Pattern.MULTILINE);

		matchText = ch;
		matcher = pattern.matcher(matchText);
	}

	public static SchemaMatchExpression match(CharSequence pText, String schemaName)
	{
		return new SchemaMatchExpression(pText, schemaName);
	}

	public int end()
	{
		return matcher.end();
	}

	public int end(int group)
	{
		return matcher.end(group);
	}

	public int start()
	{
		return matcher.start();
	}

	public int start(int group)
	{
		return matcher.start(group);
	}

	public String replaceAll(String replacement)
	{
		return matcher.replaceAll(replacement);
	}

	public String replaceAll(RegExpIterator it)
	{
		String match = matchText.toString();
		String str = "";
		int end = -1;

		while (hasNext())
		{
			str += match.substring(end == -1 ? 0 : end, start());
			str += it.replaceMatch(this);
			end = end();
		}

		str += match.substring(end == -1 ? 0 : end, match.length());
		return str;
	}

	public boolean matches()
	{
		return matcher.matches();
	}

	public boolean hasNext()
	{
		return matcher.find();
	}

	public int groupCount()
	{
		return matcher.groupCount();
	}

	public String group()
	{
		return matcher.group();
	}

	public String group(int i)
	{
		return matcher.group(i);
	}

	public SchemaMatchExpression resetMatch(CharSequence seq, String schemaName)
	{
		return match(seq, schemaName);
	}

	public String group(String name)
	{
		return matcher.group(groupOffsets.get(name).intValue());
	}

	private static String scope(String text, String name)
	{
		return text.replaceAll("(\\(\\?')(\\w+')", "$1" + name + ".$2");
	}

	public final String getschemaNameParameter()
	{
		return parameter_schemaName;
	}



	public String toString()
	{
		return "{SchemaMatchExpression, matchText='" + matchText + "'}[" + "]";
	}

	public static void main(String [] argv)
	{
		System.out.println(PATTERN_RAW_TEXT);
	}
}